/***************************************************************************/
/*								   	   */
/*                            PROGRAM SYSTMSG                              */
/*									   */
/*  Author:	Larry Towner						   */
/*  Date:	06/16/87						   */
/*  Compiler:	High C 							   */
/*  Purpose:	Inter-nationalize messages.				   */
/*  Versions:								   */
/*		Date	   Author   Comments		   		   */
/*		--------   ------   -------------------------------------- */
/*		06/13/87   LDT	    Created.				   */
/*									   */
/***************************************************************************/
/* INCLUDES:							   	   */
/***************************************************************************/
#include "portab.h"
#include "constrct.h"

/* Used by library functions and possibly SYSTAB */
BYTE	*vcname = "vc000\\console";
BYTE	*con	= "con";
BYTE	*stdi	= "stdin";
BYTE	*stdo	= "stdout";
BYTE	*stde	= "stderr";
BYTE	*swchar = "switchar";
BYTE	*path	= "path";
BYTE	*stime	= "stime.286";
BYTE	*selmsg = "Select: LETTER or <CR>, Cursor Up = <^E>, Down = <^W>, <ESC> = Exit";

/* border makers ( these do not port to certain crt's */
BYTE	midline = 0xdb;
BYTE	topline = 0xdc;
BYTE	leftline= 0xdd;
BYTE	rghtline= 0xde;
BYTE	botmline= 0xdf;
/*	Below are astericks
BYTE	midline = 0x2A;
BYTE	topline = 0x2A; 
BYTE	leftline= 0x2A;
BYTE	rghtline= 0x2A;
BYTE	botmline= 0x2A;
*/

/* Used by SYSTAB only */
BYTE	*info	= "INFORMATION : ";
BYTE	*page	= "Page ";
BYTE	*anykey = " Any key exits to the main menu ";
BYTE	*notable= "No table entries found.";
BYTE	*colon	= ":";
BYTE	*smcolon= "sm:";
BYTE	*ceabort = "SYSTAB has been aborted.";
BYTE	*endmsg = " End of Systab. ";
BYTE	*err1	= "An error occurred parsing the command line...\n";
BYTE	*err2	= "Valid command line options are as follows :";
BYTE	*usage	= "\nUsage is : \nSYSTAB [(switchar)abcdefghijklp[123456789]t?...]";
BYTE	*cmdlmsg= "Command line only options :";
BYTE	*pausmsg= " Pause the number of seconds indicated (# = 0 - 9), between\
\n\r      table lookups.  1 second is the default, 0 = continuous display.";
BYTE	*timemsg= " Display the current time.";
BYTE	*helpmsg= " Display this help message.";
BYTE	*loaderr= "\nSYSTAB : Error loading ";
BYTE	*seaerr = " could not be found in the current path.";
BYTE	*menuerr= "\nA fatal error occurred creating the SYSTAB menu.";
BYTE	*errnum = "\nError #[ ";
BYTE	*taberr	= " ] was returned while getting table #";
BYTE	*lkperr = " ] was returned while looking up table #";
BYTE	*vconerr= " ] was returned while creating a virtual console for ";
BYTE	*cmderr = " ] was returned while attempting to load the program ";
BYTE	*memerr = " ] was returned while attempting to allocate memory.";

BYTE	*lfeed	= "\n";

BYTE	*title1 = "  SYSTAB   ";
BYTE	*title2 = " Main Menu "; 

BYTE	*menu[] = {
	" Display all tables.",
	" Process Table.",
	" Pipe Table.",
	" Device Table.",
	" Vconsole Table.",
	" Sysdef Table.",
	" Procdef Table.",
	" Shmem Table.",
	" Environ Table.",
	" Console Table.",
	" Memory Table.",
	" System Table.",
	" Exit Program."
};

BYTE	*lkup_name[] = {
	"*",
	"pi:*",
	"*:",
	"con0:*",
	"*",
	"*",
	"sm:*",
	"",
	"",
	"",
	""
};

BYTE	table_num[] = {
	PROCESS_T,
	PIPE_T,
	DEVICE_T,
	VCON_T,
	SYSDEF_T,
	PROCDEF_T,
	SHMEM_T,
	ENVIRON_T,
	CONSOLE_T,
	MEMORY_T,
	SYSTEM_T
};

BYTE table_siz[] = {
	PROCESIZ,
	PIPESIZ,
	DEVSIZ,
	VCONSIZ,
	DEFSIZ,
	DEFSIZ,
	SHMSIZ,
	ENVSIZ,	
	CONSIZ,
	MEMSIZ,
	SYSSIZ
};

BYTE	*name_head[] = {
	"PROCESS ",
	"PIPE ",
	"DEVICE ",
	"VCONSOLE ",
	"SYSTEM DEFINITION ",
	"PROCESS DEFINITION ",
	"SHARED MEMORY ",
	"ENVIRONMENT ",
	"CONSOLE ",
	"MEMORY ",
	"SYSTEM "
};

BYTE	*info_head[] = {
/* process */
"PID   VCID  NAME        STATUS  PRI   FLAG   EVENTS    CODE    DATA    HEAP\n\
----  ----  ----------  ------  ----  ----  --------  ------  ------  ------  ",
/* pipe */
"KEY   NAME        BUFSIZE  RECSIZE  WORLD GROUP OWNER\n\
----  ----------  -------  -------  ----- ----- -----",
/* device */
"KEY   NAME        TYPE      ACCESS        STATUS\n\
----  ----------  --------  - ---- ----   ------------------",
/* vconsole */
"KEY      MODE VC#   TYPE    VR VC NR NC PR PC ROW COL TOP BOT LFT RHT\n\
-------- ---- ---  -- ----  -- -- -- -- -- -- --- --- --- --- --- ---",
/* system define */
"KEY   LNAME       PREFIX\n\
----  ----------  ------------------------------------------------------------",
/* process define */
"KEY   LNAME       PREFIX\n\
----  ----------  ------------------------------------------------------------",
/* shared memory */
"KEY       NAME         SIZE  SECR  USER  GRUP  SBUFFER\n\
--------  -----------  ----  ----  ----  ----  ---------",
/* environment */
"STDIN     STDOUT    STDERR    OVERLAY   SECR  USR  GRP  FID   PID\n\
--------  --------  --------  --------  ----  ---  ---  ----  --------",
/* console */
"THEAD  SCRN  KEY BOARD      CROW  CCOL  NROW  NCOL  VCNM  TYPE     CON NAME\n\
-----  ----  --- ---- ----  ----  ----  ----  ----  ----  -- ----  ----------",
/* memory */
"FREE Memory    TOTAL Memory    SYS Memory\n\
-----------    ------------    ----------",
/* system */
"CPU       OS TYPE     VER  REL  SERIAL #  IDLECNT\n\
--------  ----------  ---  ---  --------  --------"
};

BYTE	*prc_stat[] = {
	"Run",
	"Wait",
	"Term",
	"Shared",
	"******"
};

BYTE	*pipe_stat[] = {
	"r",
	"w",
	"e",
	"d  ",
	"0",
	"0",
	"0",
	"0  "
};

BYTE	*device_type[] = {
	"Kernel",
	"Disk",
	"Console",
	"Exten.",
	"Network",
 	"Misc.",
	"Special"
};

BYTE	*device_instat[] = {
	"  Uninstalled Drvr",
	"  Sub_drvr Required",
	"  Resource Manager",
	"  Owned by - ",
	"  Removable sub_drvr"
};

BYTE	*zero_one[] = {
	"0",
	"1"
};

BYTE	*cputype[] = {
	"",
	"8080",
	"8085",
	"Z80",
	"8086",
	"Z8000",
	"68000",
	"68010",
	"68020",
	"80286",
	"80386",
	"80186",
	"Reserved"
};

BYTE	*ostype[] = {
	"FlexOS",
	"Reserved"
};
